---
title: Table of Contents with Question Progress Indicators
product: Form Library
description: Customize SurveyJS Table of Contents items to show each page title, answered question count, and total question count. View this demo for JavaScript to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Table of Contents with Question Progress Indicators (React)

This example demonstrates how to customize Table of Contents items by assigning a custom item template to the [`tocItemComponent`](/form-library/documentation/api-reference/survey-data-model#tocItemComponent) property. The custom template displays each page title along with the number of answered questions and the total number of questions on that page.

To create a custom TOC item template, follow these steps:

1. Create a component that defines the item layout.\
The component receives the [`PageModel`](/form-library/documentation/api-reference/page-model) and [`SurveyModel`](/form-library/documentation/api-reference/survey-data-model) instances through the `page` and `survey` props. Use the page's [`navigationTitle`](/form-library/documentation/api-reference/page-model#navigationTitle), [`title`](/form-library/documentation/api-reference/page-model#title), or [`name`](/form-library/documentation/api-reference/page-model#name) property to display the page label. Call [`getProgressInfo()`](/form-library/documentation/api-reference/page-model#getProgressInfo) to get the `answeredQuestionCount` and `questionCount` values. To keep the counter in sync with answered questions, include the page and its questions in the component state.

2. Register the component under a name.\
In React and other JavaScript applications, register the component in `ReactElementFactory`.\
In Angular, register it in `AngularComponentFactory`.\
In Vue, register it as an application component.

3. Specify the component name in the survey configuration.\
Assign the registered component name to the survey's [`tocItemComponent`](/form-library/documentation/api-reference/survey-data-model#tocItemComponent) property. You can set this property in code or in the survey JSON schema. This demo uses the JSON schema approach shown in the Code tab.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { ReactElementFactory, SurveyElementBase } from "survey-react-ui";


class CustomTOCItem extends SurveyElementBase {
  get page() {
    return this.props.page;
  }
  get survey() {
    return this.props.survey;
  }
  getStateElements() {
    const page = this.page;
    if (!page) return [];
    return [page, ...page.questions];
  }
  render() {
    const page = this.page;
    if (!page) return null;

    const title = page.navigationTitle || page.title || page.name;
    const info = page.getProgressInfo();

    return (
      <div className="toc-item-demo">
        <span>{title}</span>
        <span className="toc-item-demo__count">
          {info.answeredQuestionCount}/{info.questionCount}
        </span>
      </div>
    );
  }
}

ReactElementFactory.Instance.registerElement(
  "sv-custom-toc-item",
  (props) => React.createElement(CustomTOCItem, props)
);



function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
.toc-item-demo {
  display: flex;
  justify-content: space-between;
  align-items: center;
  gap: 8px;
  width: 100%;
}

.toc-item-demo__count {
  flex-shrink: 0;
  opacity: 0.65;
  font-size: 0.85em;
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "showTOC": true,
  "tocItemComponent": "sv-custom-toc-item",
  "pages": [
    {
      "name": "personal",
      "title": "Profile",
      "elements": [
        {
          "type": "text",
          "name": "firstName",
          "title": "First name"
        },
        {
          "type": "text",
          "name": "lastName",
          "title": "Last name"
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email",
          "inputType": "email"
        }
      ]
    },
    {
      "name": "preferences",
      "title": "Preferences",
      "elements": [
        {
          "type": "checkbox",
          "name": "interests",
          "title": "What are your interests?",
          "choices": ["Sports", "Music", "Travel", "Cooking"]
        },
        {
          "type": "radiogroup",
          "name": "contact",
          "title": "How would you like us to contact you?",
          "choices": ["Email", "Phone", "None"]
        }
      ]
    },
    {
      "name": "feedback",
      "title": "Review",
      "elements": [
        {
          "type": "comment",
          "name": "notes",
          "title": "Additional comments"
        },
        {
          "type": "rating",
          "name": "rating",
          "title": "How would you rate this form?",
          "rateMax": 5
        }
      ]
    }
  ]
}
;
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "babel": "latest",
    
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/vue3js.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/vanillajs.md)


---
title: Table of Contents with Question Progress Indicators
product: Form Library
description: Customize SurveyJS Table of Contents items to show each page title, answered question count, and total question count. View this demo for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Table of Contents with Question Progress Indicators (Angular)

This example demonstrates how to customize Table of Contents items by assigning a custom item template to the [`tocItemComponent`](/form-library/documentation/api-reference/survey-data-model#tocItemComponent) property. The custom template displays each page title along with the number of answered questions and the total number of questions on that page.

To create a custom TOC item template, follow these steps:

1. Create a component that defines the item layout.\
The component receives the [`PageModel`](/form-library/documentation/api-reference/page-model) and [`SurveyModel`](/form-library/documentation/api-reference/survey-data-model) instances through the `page` and `survey` props. Use the page's [`navigationTitle`](/form-library/documentation/api-reference/page-model#navigationTitle), [`title`](/form-library/documentation/api-reference/page-model#title), or [`name`](/form-library/documentation/api-reference/page-model#name) property to display the page label. Call [`getProgressInfo()`](/form-library/documentation/api-reference/page-model#getProgressInfo) to get the `answeredQuestionCount` and `questionCount` values. To keep the counter in sync with answered questions, include the page and its questions in the component state.

2. Register the component under a name.\
In React and other JavaScript applications, register the component in `ReactElementFactory`.\
In Angular, register it in `AngularComponentFactory`.\
In Vue, register it as an application component.

3. Specify the component name in the survey configuration.\
Assign the registered component name to the survey's [`tocItemComponent`](/form-library/documentation/api-reference/survey-data-model#tocItemComponent) property. You can set this property in code or in the survey JSON schema. This demo uses the JSON schema approach shown in the Code tab.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "showTOC": true,
  "tocItemComponent": "sv-custom-toc-item",
  "pages": [
    {
      "name": "personal",
      "title": "Profile",
      "elements": [
        {
          "type": "text",
          "name": "firstName",
          "title": "First name"
        },
        {
          "type": "text",
          "name": "lastName",
          "title": "Last name"
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email",
          "inputType": "email"
        }
      ]
    },
    {
      "name": "preferences",
      "title": "Preferences",
      "elements": [
        {
          "type": "checkbox",
          "name": "interests",
          "title": "What are your interests?",
          "choices": ["Sports", "Music", "Travel", "Cooking"]
        },
        {
          "type": "radiogroup",
          "name": "contact",
          "title": "How would you like us to contact you?",
          "choices": ["Email", "Phone", "None"]
        }
      ]
    },
    {
      "name": "feedback",
      "title": "Review",
      "elements": [
        {
          "type": "comment",
          "name": "notes",
          "title": "Additional comments"
        },
        {
          "type": "rating",
          "name": "rating",
          "title": "How would you rate this form?",
          "rateMax": 5
        }
      ]
    }
  ]
}
;
```

### `src/app/components/survey.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/toc-custom-item.component.css`

```css
.toc-item-demo {
  display: flex;
  justify-content: space-between;
  align-items: center;
  gap: 8px;
  width: 100%;
}

.toc-item-demo__count {
  flex-shrink: 0;
  opacity: 0.65;
  font-size: 0.85em;
}
```

### `src/app/components/toc-custom-item.component.html`

```html
<div class="toc-item-demo">
  <span>{{ title }}</span>
  <span class="toc-item-demo__count">
    {{ answeredQuestionCount }}/{{ questionCount }}
  </span>
</div>
```

### `src/app/components/toc-custom-item.component.ts`

```ts
import { Component, Input, OnDestroy, OnInit } from "@angular/core";
import { AngularComponentFactory, BaseAngular } from "survey-angular-ui";
import { PageModel, SurveyModel } from "survey-core";

@Component({
  // tslint:disable-next-line:component-selector
  selector: "sv-ng-custom-toc-item",
  templateUrl: "./toc-custom-item.component.html",
  styleUrls: ["./toc-custom-item.component.css"],
})
export class CustomTocItem extends BaseAngular<PageModel> implements OnInit, OnDestroy {
  @Input() page!: PageModel;
  @Input() survey!: SurveyModel;

  private readonly onValueChanged = () => {
    this.update();
  };

  protected getModel(): PageModel {
    return this.page;
  }

  ngOnInit(): void {
    this.survey?.onValueChanged.add(this.onValueChanged);
  }

  override ngOnDestroy(): void {
    this.survey?.onValueChanged.remove(this.onValueChanged);
    super.ngOnDestroy();
  }

  get title(): string {
    const page = this.page;
    if (!page) return "";
    return page.navigationTitle || page.title || page.name;
  }

  get answeredQuestionCount(): number {
    return this.page?.getProgressInfo().answeredQuestionCount ?? 0;
  }

  get questionCount(): number {
    return this.page?.getProgressInfo().questionCount ?? 0;
  }
}

AngularComponentFactory.Instance.registerComponent(
  "sv-custom-toc-item",
  CustomTocItem
);
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { CustomTocItem } from "./toc-custom-item.component";


@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    static declaration = [CustomTocItem];
    
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";
import { CustomTocItem } from "./components/toc-custom-item.component";


@NgModule({
    declarations: [AppComponent, SurveyComponent, CustomTocItem
    ],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.toc-item-demo {
  display: flex;
  justify-content: space-between;
  align-items: center;
  gap: 8px;
  width: 100%;
}

.toc-item-demo__count {
  flex-shrink: 0;
  opacity: 0.65;
  font-size: 0.85em;
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/vue3js.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/table-of-contents-with-question-progress/vanillajs.md)
